/* yasep/ISM/ISM.js
 This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
 created lun. sept. 12 08:52:50 CEST 2011
 version dim. sept. 18 17:25:04 CEST 2011 : adding the ISM/presentation.js code
 version lun. sept. 19 08:45:47 CEST 2011 : translations OK

 This is a generic page loader for the /ISM/ directory, it also handle aliases.
 */

ISM={
  win: null,

//// English :

  L:[
   ["Syntax examples :", "JavaScript properties of this opcode :"   ,
        "<br>&nbsp;Opcode number : ",'<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Group : ',
        '<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Forms : ','   With condition  ',
        '<p>&#8226; Look at the <a href="#doc/mul">multiply page</a> for more informations on how to use this instruction.',
        '<p>&#8226; This opcode is an <a href="#!doc/asm#asm_aliases">alias</a> to the <a class="opcode">', '</a> instruction.</p>',
        '<p>&#8226; When using the "long immediate" form (<a href="#!doc/forms#FORM_IRR">IRR</a>), only the 5 least significant bits are used with YASEP32, and 4 bits with YASEP16.'
       +'<p>&#8226; When using the "short immediate" form (<a href="#!doc/forms#FORM_iR">iR</a>),  only 4 bits are available, be careful with YASEP32&nbsp;: use the long form for shifts between 16 to 31 positions.',
        '<p>&#8226; When using the "long immediate" form (<a href="#!doc/forms#FORM_IRR">IRR</a>), only the 8 least significant bits are used.',
        '<p>&#8226; This instruction is <a href="#!doc/flags#OPTIONAL">optional</a> and could be invalid, depending on the target core\'s implementation.</p>',
        '<p>&#8226; This instruction is specific to <a href="#!doc/flags#YASEP32_ONLY">YASEP32</a> and has no meaning with a 16-bit version.</p>',
        '<p>&#8226; This instruction is specific to <a href="#!doc/flags#YASEP16_ONLY">YASEP16</a> and has no meaning with a 32-bit version.</p>',
        '<p>&#8226; You can play with this instruction in the <a href="#!tool/test_eu">Execution Unit simulator</a>.</p>\n',
        '<br>&nbsp;&nbsp;&nbsp;Description : ',
'then <tt><b>si4</b></tt> is written to<ul>'+
' <li> <tt><b>snd</b></tt> (short forms)'+
' <li> <tt><b>si4</b></tt> (long immediate form)'+
' <li> <tt><b>dst3</b></tt> (extended forms).</ul></p>',
        '<p>&#8226; This instruction usually works by comparing the values (with a substraction) then conditionally aborting the write of <tt><b>si4</b></tt>. The long forms may not work in some versions of the core.</p>'
       +'<p>&#8226; The <a class="opcode">SMAX</a> (Signed MAXimum), <a class="opcode">SMIN</a> (Signed MINimum), <a class="opcode">UMAX</a> (Unsigned MAXimum) and <a class="opcode">UMIN</a> (Unsigned MINimum) instructions are useful when clipping coordinates or sound samples, for example.</p>'+
'<pre class="instr">'+
'; Signed version :\n'+
' <a class="asm">SMAX R1 R2</a>       ; If R1&gt;R2    then R1->R2\n'+
' <a class="asm">SMAX 1234h R1 R2</a> ; If R1&gt;1234h then R1->R2 else 1234h->R2\n'+
' <a class="asm">SMIN R1 R2</a>       ; If R1&lt;R2    then R1->R2\n'+
' <a class="asm">SMIN 1234h R1 R2</a> ; If R1&lt;1234h then R1->R2 else 1234h->R2\n'+
'; Unsigned version :\n'+
' <a class="asm">UMAX R1 R2</a>       ; If R1&gt;R2    then R1->R2\n'+
' <a class="asm">UMAX 1234h R1 R2</a> ; If R1&gt;1234h then R1->R2 else 1234h->R2\n'+
' <a class="asm">UMIN R1 R2</a>       ; If R1&lt;R2    then R1->R2\n'+
' <a class="asm">UMIN 1234h R1 R2</a> ; If R1&lt;1234h then R1->R2 else 1234h->R2</pre>',
 '<p>&#8226; Hint with YASEP32 : The <a class="opcode">ROR</a> and <a class="opcode">ROL</a> instruction are complementary. If a register must be ROLed by more than 15 positions, ROR the register by 32-n positions. This saves two instruction bytes...'
+'<pre class="instr"><a class="asm">ROR 21 R1</a> ; 21 > 15 so a long instruction is used\n'
+'<a class="asm">ROL 11 R1</a> ; 32-21 = 11 &lt; 15 so a short instruction is used to do the same thing</pre></p>',
'<li> a 4-bit immediate value (short immediate <a href="#!doc/forms#FORM_iR">iR</a> or extended immediate <a href="#!doc/forms#FORM_iRR">iRR</a> forms)<li> the other register (<tt><b>si4</b></tt>) (short register form <a href="#!doc/forms#FORM_RR">RR</a> or extended register form <a href="#!doc/forms#FORM_RRR">RRR</a>)<li> a 16-bit value (long immediate form (<a href="#!doc/forms#FORM_IRR">IRR</a>)).',
'<p><i>This instruction is optional and not definitive, so it could change later.</i></p><p>This is an unsigned operation, signed multiplies are not (yet) supported. The results can be combined (by <a class="opcode">ADD</a>) with the result of other <a class="opcode">MUL8H</a> and <a class="opcode">MUL8L</a>, as explained in the the <a href="#!doc/mul">documentation</a>.</p>',
 '<p>&#8226; <a class="opcode">CMPU</a> and <a class="opcode">CMPS</a> have been created to reduce the pressure on the register set, as 5 registers only are available&nbsp;: having <a class="opcode">SUB</a> with no register writeback saves one precious register that would hold the discarded result.</p>',
 '<p>&#8226; This instruction is <b>preliminary</b>, it is not yet completely defined, do not use it !</p>'
   ],

//// Français :

   ["Exemples de syntaxe :", "Propriétés JavaScript de cet opcode :","<br>&nbsp;&nbsp;&nbsp;n° d'opcode : ",
        '<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Groupe : ', '<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Formes : ','   Avec condition  ',
        '<p>&#8226; Consultez la <a href="#doc/mul">page sur les multiplcations</a> pour de plus amples détails sur l\'utilisation de cet opcode.',
        '<p>&#8226; Cet opcode est un <a href="#!doc/asm#asm_aliases">alias</a> vers l\'instruction <a class="opcode">', '</a>.</p>',
        '<p>&#8226; Avec la forme "longue immédiate" (<a href="#!doc/forms#FORM_IRR">IRR</a>), seuls les 5 bits de poids faible sont pris en compte par YASEP32, et 4 bits avec YASEP16.'
       +'<p>&#8226; Avec la forme "courte immediate" (<a href="#!doc/forms#FORM_iR">iR</a>),   seulement 4 bits sont disponibles, faites attention avec YASEP32&nbsp;: utilisez une forme longue pour les décalages de 16 à 31 bits)',
        '<p>&#8226; Avec la forme "longue immédiate" (<a href="#!doc/forms#FORM_IRR">IRR</a>), seuls les 8 bits de poids faible sont pris en compte.',
        '<p>&#8226; Cette instruction est <a href="#!doc/flags#OPTIONAL">optionnelle</a> et peut être invalide sur certains YASEP.</p>',
        '<p>&#8226; Cette instruction est spécifique à <a href="#!doc/flags#YASEP32_ONLY">YASEP32</a> et n\'a aucun sens avec une version 16 bits.</p>',
        '<p>&#8226; Cette instruction est spécifique à <a href="#!doc/flags#YASEP16_ONLY">YASEP16</a> et n\'a aucun sens avec une version 32 bits.</p>',
        '<p>&#8226; Vous pouvez expérimenter avec cette opération dans le <a href="#!tool/test_eu">simulateur d\'unités d\'exécution</a>.</p>\n',
        '<br>&nbsp;&nbsp;&nbsp;Description : ',
'alors <tt><b>si4</b></tt> est écrit dans&nbsp;:<ul>'+
' <li> <tt><b>snd</b></tt> (formes courtes)'+
' <li> <tt><b>si4</b></tt> (forme immédiate longue)'+
' <li> <tt><b>dst3</b></tt> (formes étendues).</ul></p>',
        '<p>&#8226; Cette instruction fonctionne en comparant les deux opérandes (avec une soustraction) puis, selon la retenue, en permettant l\'écriture de <tt><b>si4</b></tt>. C\'est plus complexe pour les formes longues donc elles risquent de ne pas fonctionner sur certaines version du YASEP.</p>'
       +'<p>&#8226; Les instructions <a class="opcode">SMAX</a> (Signed MAXimum), <a class="opcode">SMIN</a> (Signed MINimum), <a class="opcode">UMAX</a> (Unsigned MAXimum) et <a class="opcode">UMIN</a> (Unsigned MINimum) sont utiles pour les calculs avec saturation par exemple (<i>clipping</i> de coordonnées graphiques ou d\'échantillons de son, par exemple).</p>'+
'<pre class="instr">'+
'; Version signée :\n'+
' <a class="asm">SMAX R1 R2</a>       ; Si R1&gt;R2    alors R1->R2\n'+
' <a class="asm">SMAX 1234h R1 R2</a> ; Si R1&gt;1234h alors R1->R2 sinon 1234h->R2\n'+
' <a class="asm">SMIN R1 R2</a>       ; Si R1&lt;R2    alors R1->R2\n'+
' <a class="asm">SMIN 1234h R1 R2</a> ; Si R1&lt;1234h alors R1->R2 sinon 1234h->R2\n'+
'; Version non signée :\n'+
' <a class="asm">UMAX R1 R2</a>       ; Si R1&gt;R2    alors R1->R2\n'+
' <a class="asm">UMAX 1234h R1 R2</a> ; Si R1&gt;1234h alors R1->R2 sinon 1234h->R2\n'+
' <a class="asm">UMIN R1 R2</a>       ; Si R1&lt;R2    alors R1->R2\n'+
' <a class="asm">UMIN 1234h R1 R2</a> ; Si R1&lt;1234h alors R1->R2 sinon 1234h->R2\n</pre>',
 '<p>&#8226; Astuce avec YASEP32 : Les instructions <a class="opcode">ROR</a> et <a class="opcode">ROL</a> sont complémentaires. Si un registre doit être décalé circulairement de plus de 15 positions avec ROL, on obtient le même résultat avec un ROR de 32-n positions pour sauver 2 octets de mémoire programme.'
+'<pre class="instr"><a class="asm">ROR 21 R1</a> ; 21 > 15 donc une instruction longue est nécessaire\n'
+'<a class="asm">ROL 11 R1</a> ; 32-21 = 11 &lt; 15 donc une instruction courte obtient le même résultat</pre></p>',
'<li> une valeur immédiate sur 4 bits (forme immédiate courte <a href="#!doc/forms#FORM_iR">iR</a> ou étendue <a href="#!doc/forms#FORM_iRR">iRR</a>)<li> un autre registre source (<tt><b>si4</b></tt>) (formes courte à registre <a href="#!doc/forms#FORM_RR">RR</a> ou étendue <a href="#!doc/forms#FORM_RRR">RRR</a>)<li> une valeur immédiate sur 16 bits (forme longue immédiate (<a href="#!doc/forms#FORM_IRR">IRR</a>)).',
 '<p><i>Cette instruction est optionnelle, non définitive et peut changer dans le futur.</i></p><p>C\'est une opération non signée, les multiplications signées ne sont pas encore supportées. Le résultat peut être combiné (avec <a class="opcode">ADD</a>) avec les résultats d\'autres instructions <a class="opcode">MUL8L</a> et <a class="opcode">MUL8H</a>, comme expliqué dans la <a href="#!doc/mul">documentation</a>.</p>',
 '<p>&#8226; <a class="opcode">CMPU</a> et <a class="opcode">CMPS</a> existent pour réduire les contraintes lors de l\'allocation des registres. Ils évitent d\'immobiliser un registre pour la destination de la soustraction.</p>',
 '<p>&#8226; Cette instruction est <b>préliminaire</b>, sa définition est en cours et les mécanismes ne sont pas encore correctement définis. Ne pas utiliser !</p>'
   ]
  ],

  start: function(target, orig_alias) {
    target=target.slice(4);
    orig_alias=orig_alias.slice(4); // remove "ISM/"
    var l=ISM.L[LANG.LANG];
    var cont=document.createElement("DIV");
    ISM.cont=cont;
    cont.innerHTML=import_htmi("ISM/"+orig_alias)+
'<p id="doc"></p>'+
'<h3>'+l[0]+'</h3>\n'+
'<pre id="example" class="instr">\n'+
'</pre>\n'+
'<h3>'+l[1]+'</h3>\n'+
'<div id="dump">\n'+
'</div>\n';

    ISM.win = ygwm.new_window(
       "Opcode "+orig_alias, null, cont,
       500, 400, 250, 250, false, true, true, true, false, "doc_yelo");

/* yasep/ISM/presentation.js
created 2007-03-28 by yann guidon
2007-11-05 : rebranding to YASEP
2009-07-09 : changed before_load to addLoadEvent
2009-08-09
2009-08-23
*/

/* inclusion of yasep/ISM/dump_opcode_table.js
created 2007-03-28 by yann guidon
2007-04-01 : added the IR notice
2007-04-08
2007-04-16
2007-04-17 : allowing aliases
2007-11-05 : rebranding to YASEP
2007-11-07 : some healthy updates
2007-12-25 : changed the condition to display the link to test_eu.html
2007-11-?? : added support for OPTIONAL|YASEP32_ONLY|YASEP16_ONLY
2007-11-30 : test_eu turned into test_eu16 and test_eu32
2008-12-27 : included in yasep/ISM/presentation.js as after_load to make it work under Opera
2009-01-08 : changed after_load to before_load
*/

  var x=getById('doc','p',cont);
  var y=getById('example','pre',cont);
  var z=getById('dump','div',cont);
  var op=orig_alias;

  var s='';
  var u='';
  var m='';

  if (Y.table_opcode[op] != undefined) {
    if ((target=="UMIN")||(target=="UMAX")||(target=="SMIN")||(target=="SMAX")) {
      getById('minmax','span',cont).innerHTML=l[16];
      m+=l[17];
    }

    if ((target=="ROR")||(target=="ROL"))
      m+=l[18];

    if ((target=="CMPU")||(target=="CMPS"))
      m+=l[21];

    var e=getById('rotrol','ul',cont);
    if (e)
      e.innerHTML=l[19];

    var e=getById('Mul8','div',cont);
    if (e)
      e.innerHTML=l[20];


    if (Y.opcode_aliases[target])
      m+=l[7]+Y.opcode_aliases[target]+l[8];

  /* display the properties */
    var o=Y.table_opcode[op];
        t=o.val,
        e=t & Y.FIELD_GROUP,
        f=o.forms,
        g=o.flags;

    s='&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Opcode : '+op+'\n'+l[2]+int2hex(t)+'\n';

    if (Y.GroupNames[e])
   s+=l[3]+Y.GroupNames[e].replace(/GROUP_/,'')+'\n';

    if (e == Y.GROUP_MUL)
      m+=l[6];

    if (g & Y.IMM16_5LSB)
      m+=l[9];

    if (g & Y.IMM16_8LSB)
      m+=l[10];

    if (e==Y.GROUP_ROP2)
      m+='<p><table border="1">'
        +'<tr><td>si4</td><td>snd</td><td></td><td><a href="#!ISM/AND">AND</a></td><td><a href="#!ISM/ANDN">ANDN</a></td>'
        +'<td><a href="#!ISM/NAND">NAND</a></td><td><a href="#!ISM/OR">OR</a></td><td><a href="#!ISM/ORN">ORN</a></td><td>'
        +'<a href="#!ISM/NOR">NOR</a></td><td><a href="#!ISM/XOR">XOR</a></td><td><a href="#!ISM/XORN">XORN</a></td></tr>'
        +'<tr><td>0</td><td>0</td><td></td><td>0</td><td>0</td><td>1</td><td>0</td><td>1</td><td>1</td><td>0</td><td>1</td></tr>'
        +'<tr><td>0</td><td>1</td><td></td><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>'
        +'<tr><td>1</td><td>0</td><td></td><td>0</td><td>1</td><td>1</td><td>1</td><td>1</td><td>0</td><td>1</td><td>0</td></tr>'
        +'<tr><td>1</td><td>1</td><td></td><td>1</td><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td></tr>'
        +'</table></p>';

//flags : OPTIONAL|YASEP32_ONLY|YASEP16_ONLY
    if (g & Y.OPTIONAL)
      m+=l[11];

    if (g & Y.Preliminary)
      m+=l[22];

    if (g & Y.YASEP32_ONLY)
      m+=l[12];

    if (g & Y.YASEP16_ONLY)
      m+=l[13];

    if ((typeof(Y.opcode_table[t].action32) == "function")
    ||  (typeof(Y.opcode_table[t].action16) == "function"))
      m+=l[14];

    if (o.description)
   s+=l[15]+o.description+'\n';
 
   s+=l[4]+Y.form2html(f)+'\n';

/* generate the examples */
    var i,j,k,n,fill='                ';
    for (i in Y.TableForm) {
      if (f & i) {
        j=Y.TableForm[i];
        k=j.replace(/FORM_/,'');

        n=Y.TableFormFunction[i](g);
        if (n!='')
          n=op+" "+n;
        else
          n=op;

        u+=' - <a href="#!doc/forms#FORM_'+k+'">'+j+'</a>'
          +fill.slice(j.length)+'<a class="asm">'+n+'</a>\n';
        if ((i & Y.FORMS_EXTENDABLE)&&((g & Y.NO_CONDITION)==0))
          u+=l[5]+'<a class="asm">'+n+' '+Y.randomCondition()+'</a>\n';
      }
    }

  /* the flags */
    if (g > 0) {
      s+='<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Flags :';
      for (i in Y.TableFlags) {
        if (g & i) {
          s+=' <a href="#!doc/flags#'
              +Y.TableFlags[i].replace(/FLAG_/,'')+'">'
              +Y.TableFlags[i]+'</a>';
        }
      }
   s+='\n';
    }
  } // table_opcode[op]!=undefined

  x.innerHTML=m;
  y.innerHTML=u;
  z.innerHTML=s;

    winman.patchInnerLinks(cont);

    return ISM.win;
  }
}
