/*

  yasep/dev/minimize.js : réduit la taille de code JS et CSS
  created mar. oct. 18 13:24:47 CEST 2011 by whygee@f-cpu.org
  version mar. nov. 15 10:41:28  CET 2011

    Copyright (C) 2011 Yann Guidon

Le code JavaScript de cette page est un logiciel libre : vous pouvez
le redistribuer et/ou le modifier selon les termes de la licence GNU
Affero General Public License (GNU GPL) telle que publiée par la Free
Software Foundation, en version 3 de la licence, ou (à votre discrétion)
toute version suivante. Le code est distribué SANS AUCUNE GARANTIE ;
sans même la garantie implicite de MARCHANDABILITÉ ou d'ADÉQUATION
À UN BUT PARTICULIER.  Consultez la GNU AGPL pour plus de détails.
http://www.gnu.org/licenses/agpl.html

En tant que permission supplémentaire selon les termes de la GNU GPL
version 3 section 7, vous pouvez distribuer des formes "non-source"
(par ex., minimisé ou compacté) de ce code sans la copie de la GNU GPL
normalement requise section 4, attendu que vous incluez cette notice
de licence et une URL par laquelle les destinataires peuvent accéder
au code source correspondant.
*/

JSkeyWords="abstract break boolean byte char class case catch class const continue"
 +" debugger default delete do double else enum export extends"
 +" final finally float for function goto if implements import in Infinity instanceof"
 +" int interface import let long NaN native new package private protected"
 +" public return short static super switch synchronized this throw throws transient try"
 +" typeof undefined var void volatile while with yield blackList arguments";

JS_Methods= "childNodes firstChild lastChild previousSibling nextSibling parentNode id className"
 +" getElementById getElementsByTagName removeChild replaceChild replaceData"
 +" cloneNode insertBefore appendChild appendData deleteData insertData"
 +" nodeName nodeType nodeValue innerHTML setAttribute setAttributeNode"
 +" onclick onmouseup onmousemove onmousedown onmouseover event left top scrollTop"
 +" style body cursor display apply call prototype self location top zIndex scrollLeft"
 +" src length Object indexOf height width backgroundColor caller callee"
 +" scrollBy scrollTo scrollHeight scrollWidth createElement replace target slice sort"
 +" join split floor random cookie responseText documentElement pageX pageY clientX clientY"
 +" title ceil charAt getTime toGMTString location open send substring srcElement"
 +" href onresize clientWidth clientHeight close styleSheets info charCodeAt hash"
 +" offsetLeft offsetTop push pop onchange onload value action color checked"
 +" constructor";

Aliasable="true false null" // valeurs de base
+" alert clearTimeout escape eval parseInt parseFloat setTimeout unescape" // fonctions, dont celles de l'objet global
+" Array Boolean console Date document Error Function Math Number RegExp String window XMLHttpRequest"; // objets

JSbaseObjects="arguments"  // celui-ci n'est pas aliasable
+" Array Boolean console Date document Error Function Math Number RegExp String window XMLHttpRequest";



minimize=function(src,level,dbg) {
  var src_index=0, l=src.length,
    i=0,
    EOF       =i++,
    SPACE     =i++,
    WORD      =i++,
    STRING    =i++,
    PUNCT     =i++,
    CURLY     =i++,
    SEMICOLON =i++,
    REGEXP    =i++,
    KEYWORD   =i++,
    COLON     =i++,
    INTERNAL  =i++,
    EXTERNAL  =i++,
    EMPTY     =i++,

    variableChar=[],
    variableCharStrings="#0123456789_$abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",
    VarCharIndex=[]; // table vide

  for (t in variableCharStrings)
    variableChar[variableCharStrings[t]]=t; // valeur bidon

  var dst=[], dst_type=[];
  for (var i=0; i<5; i++) {
    dst.push("");       // ajoute plein de tokens vides
    dst_type.push(EOF); // pour éviter d'avoir à tester
  }                     // la validité des indices

  var CustomBlackListLUT=[],
      ParsedWordsLUT=[],   // indices : string avec préfixe "P"
      ParsedWordsArray=[]; // indices entiers

  function newVarName() {
    var v, i;
    do {
      // incrémente les compteurs en propageant la retenue
      i=0;
      do {
        if (i>= VarCharIndex.length) // s'il n'existe pas,
          VarCharIndex[i]=10;        // crée un nouveau chiffre à "_"

        VarCharIndex[i]++;
        if (VarCharIndex[i] < variableCharStrings.length)
          break; // arrête si aucune retenue à propager.

        VarCharIndex[i++]=1; // saute le "#"
      } while (true);

      // concatène les chiffres dans v dans l'ordre décroissant
      v="";
      for (i in VarCharIndex)
        v=VarChar[VarCharIndex[i]]+v;
    } while (CustomBlackListLUT['P'+v] || ParsedWordsLUT['P'+v]);
    return v
  }



  function getChar() {
    if (src_index>=l)
      return null;
    return src[src_index++];
    // utiliser src.charAt() si compatibilité avec Internet Explorer...
  }

//////////////// L'analyse lexicale ////////////////

  function getToken() {
    var t=getChar(); // lit un premier caractère
    token=t;         // assignation spéculative

    switch(t){
      case null:  return EOF;

      case ' ':  // Espaces :
      case '\t':
      case '\r':
      case '\n':
        token=' ';
        do
          t=getChar();
        while ((t==' ') || (t=='\r')  || (t=='\n') || (t=='\t'));
        if (t==null)
          return EOF;
        src_index--; // retourne le caractère non-espace
        return SPACE;

      case "'":
      case '"':
        var u, v;
        do {
          u=getChar();
          if (u==null) { alert("chaine non fermée"); return EOF }

          // caractère d'échappement ?
          if (u=='\\') {
            v=getChar();
            if (v==null) { alert("chaine non fermée"); return EOF }
            token+=u+v;  // recopie les deux caractères
          }
          else
            token+=u;
        } while (t!=u); // caractère de fermeture = ouverture

        return STRING;

      case '/':
        u=getChar();
        switch(u) {
          case '/': // enlever jusqu'à la fin de la ligne
            do {
              u=getChar();
            } while ((u!='\n')&&(u != null));
            token=' ';
            return SPACE;

          case '*':
            token=' '; 
            do { // enlever jusqu'à "*/"
              u=getChar();
              if (u=="*"){
                u=getChar();
                if (u=="/")
                  return SPACE;
              }
            } while (u != null);
            alert("commentaire non fermé");
            return EOF;

      default: // Est-ce une regexp ?
        if ((src_index > 3) && (src[src_index-3]=='(')) {
          token+=u;

          do { // recopie tout jusqu'au "/" fermant
            u=getChar();
            if (u==null) {
              alert("regex non fermée"); return EOF }

            if (u=='\\') { // caractère d'échappement
              v=getChar();
              if (v==null) {
                alert("regex non fermée"); return EOF }
              token+=u+v;
            }
            else
              token+=u;
          } while (u!='/');

          // récupère les éventuels caractères à la fin
          while ( variableChar[u=getChar()] )
            token+=u;

          if (u!=null)
            src_index--;

          return REGEXP;
        }  // "else" implicite

        // Juste un "/" seul
        if (u!=null)
          src_index--; // retourne en arrière
        return PUNCT;
      } // fin du switch "/"

      case '}': return CURLY;
      case ';': return SEMICOLON;

      default:
        if (variableChar[t]) {
          do { // un "mot"
            t=getChar();
            if (variableChar[t])
              token+=t;
            else {
              if (t!=null)
                src_index--;

              // à cet endroit, token contient le mot entier,
              // on va vérifier si c'est un mot-clé à nous.
              if (token=="blackList") {
                token=' ';
                while((t!=';')&&(t!=null))
                  t=getChar(); // Enlève tout jusqu'à ";" inclus
                return SPACE;
              }

              return WORD;
            }
          } while (true);
        }

        return PUNCT; // default du default, tous les autres caractères
    }
  }


//////////////// L'analyse syntaxique ////////////////

  do {
    TYPE=getToken(); // on pourrait inliner l'appel...

    // Gestion de l'espace précédent
    if ((dst_type[dst.length-1] == SPACE)
      && ((TYPE!=WORD) || (dst_type[dst.length-2]!=WORD))) {
        dst.pop();       // enlève ledit espace superflu
        dst_type.pop();
    }

    switch(TYPE){
      case EOF:  // concaténation de tout le tableau dans une chaîne
        if (level=="noSubst")
          return dst.join("");

        return dst.join("");


      case SEMICOLON:  // Enlève ";" lorsqu'il est suivi de ";" ou "}"
        if (dbg)
          token=";\n";
      case CURLY:
        if (dst_type[dst.length-1] == SEMICOLON) {
          dst.pop(); // enlève le ";"
          dst_type.pop();
        }
        dst.push(token); // ajoute le "}"
        dst_type.push(TYPE);
        break;

      case STRING:
        if ((dst[dst.length-1] == "+")
         && (dst_type[dst.length-2] == STRING)
         && (token[0]==dst[dst.length-2][0])) {

          // concatène les deux chaînes
          dst[dst.length-2] =
               dst[dst.length-2].slice(0,-1)  // enlève le dernier caractère
             + token.slice(1);                // enlève le premier caractère

          dst.pop();      // enlève le "+"
          dst_type.pop();
          break; // n'ajoute pas token à dst
        }
        // else implicite, saute au code par défaut

      case WORD :
      case REGEXP:
      case SPACE:  // pas de traitement spécial
      case PUNCT: 
        // ajout d'un token
        dst.push(token);
        dst_type.push(TYPE); 
        break;

      default:
        alert("token inconnu");
        return "Erreur !!! "+ dst;
    }
  } while (true);
}