/*yasep/cookies.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created 20110808 by whygee@f-cpu.org
depends on core-js/base66s.js
this file manages the persistent user interface parameters.
a "cache" is maintained, numbers are encoded
in base66s, windows are stored as .name-xpos-ypos-xsize-ysize
cookies_cache[0]="-" to skip the introduction page, empty otherwise.
*/

init_obj.push(cookies={
  cache:[],

  // found on the 'web :
  get: function(name) {
    var start = document.cookie.indexOf(name + "="),
      len = start + name.length + 1;
    if ((!start) && (name != document.cookie.substring(0, name.length)))
      return null;
    if (start == -1)
      return null;
    var end = document.cookie.indexOf( ';', len);
    if (end == -1)
      end = document.cookie.length;
    return unescape(document.cookie.substring(len, end));
  },

  set:function( name, value, expires, path, domain, secure ) {
    var today = new Date();
    today.setTime( today.getTime() );
    if (expires)
      expires = expires * 86400000; // * 1000 * 60 * 60 * 24;
    var expires_date = new Date( today.getTime() + (expires) );
    document.cookie = name+'='+escape( value ) +
      ((expires) ? ';expires='+expires_date.toGMTString() : '' )+
      ((path)    ? ';path=' + path : '' ) +
      ((domain)  ? ';domain=' + domain : '' ) +
      ((secure)  ? ';secure' : '' );
  },

///////////////////////////////////////////////////////////////
// build the megacookie
  save:function(){
    cookies.cache[0]=""+encode_number_base66(LANG.LANG);
//    if (FF.target_loopback)
//      cookies.cache[1]=""+FF.target_loopback.replace(/[.]/g,"%2E");
//    else
      cookies.cache[1]="";
    cookies.set("a",cookies.cache.join("."),3); // expiry after 3 days
  },

///////////////////////////////////////////////////////////////
// manage the YGWM megacookie :
  init_obj: function(){
    var c=cookies.get("a");
    if (c==null)
      return;
    cookies.cache=c.split('.');
    if (cookies.cache[0])
      LANG.LANG=decode_number_base66(cookies.cache[0]+""); // make sure it's a string
//    if (cookies.cache[1] && (cookies.cache[1]!=""))
//      FF.target_loopback=cookies.cache[1].replace(/[%]2E/g,".");
  }
});
