/*
  yasep/index.dev.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
  created dim. sept. 11 03:10:21 CEST 2011
  version dim. sept. 18 14:15:54 CEST 2011 : dropped the 'skip intro' and the corresponding cookie.
  version mar. oct.  18 04:20:32 CEST 2011 : adding minimisation, moving init code to body_start.js
  version lun. nov.   7 12:56:36  CET 2011 : moving minimisation away, in a window
  contains some JS code that was in the index.html before.
  It also contains things that will not get minimised.
*/

// For the minifier
// (all mentions of "blackList();" will be removed from the minified version
function blackList(nom){
  try{
    DynamicBlackListWords+=" "+nom;
  }
  catch(e){ // create the list if not existing yet
    DynamicBlackListWords=nom;
  }
}

// Load the CSS before the JS !
css_list=['yasep', 'gui-js/ygwm', 'gui-js/winlist', 'gui-js/menu' ];
for (var i in css_list) {
  document.write('<link href="'+css_list[i]+'.css" rel="stylesheet" type="text/css">\n');
}

var js_list=[
 // column 0 : load in dev
 // column 1 : include in prod
 // column 2 : file name w/o ".js" suffix
 [1, 1, 'body_first'],
 [1, 1, 'gui-js/messages'],
 [1, 1, 'gui-js/XHR'],
 [1, 1, 'core-js/txt_int'],
 [1, 1, 'core-js/base66s'],
 [1, 1, 'gui-js/cookies'],
 [1, 1, 'gui-js/ygwm'],
 [1, 1, 'gui-js/ygwm-colors'],
 [1, 1, 'gui-js/ygwm-options'],
 [1, 1, 'gui-js/winlist'],
 [1, 1, 'gui-js/menu'],
 [1, 1, 'gui-js/winman'],
 [1, 1, 'gui-js/lang'],

 [1, 1, 'ISM/ISM'], // ISM is pointed to by core-js/yasep_opcodes.js:Y.NewOpcode

 [1, 1, 'core-js/yasep_forms'],
 [1, 1, 'core-js/yasep_fields'],
 [1, 1, 'core-js/yasep_flags'],
 [1, 1, 'core-js/yasep_opcodes'],
 [1, 1, 'core-js/yasep_groups'],
 [1, 1, 'core-js/yasep_conditions'],

// [1, 1, 'core-js/group_eu'], // parts of the future simulator
 [1, 1, 'core-js/group_ctl'],
 [1, 1, 'core-js/group_asu'],
 [1, 1, 'core-js/group_rop2'],
 [1, 1, 'core-js/group_shl'],
 [1, 1, 'core-js/group_ie'],
 [1, 1, 'core-js/group_smt'],
 [1, 1, 'core-js/group_mul'],
 [1, 1, 'core-js/group_rsv'],

 [1, 1, 'core-js/yasep_pseudo'],
 [1, 1, 'core-js/yasep_asm'],
 [1, 1, 'core-js/yasep_disasm'],

 [1, 1, 'tool/test_opcodes'],
 [1, 1, 'doc/opcode_map'],
 [1, 1, 'tool/asm'],
 [1, 1, 'doc/doc'],
 [1, 1, 'doc/forms'],
 [1, 1, 'doc/asm'],
 [1, 1, 'doc/16-32'],
 [1, 1, 'defora/gen_asm'],
 [1, 1, 'test/template'],
 [1, 1, 'gui-js/welcome'],
 [1, 1, 'gui-js/filefox'],
 [1, 1, 'gui-js/savefile'],
 [1, 0, 'dev/minimize'],
 [1, 0, 'dev/compact'],
 [1, 1, 'keys'],
 [1, 1, 'body_start'] // last one
];

for (var i in js_list)
  if (js_list[i][0]==1)
    document.write('<script type="text/javascript" src="'+js_list[i][2]+'.js"></'+'script>\n');

// See also keys.js for the list of the window keys
// (it can't be placed here because it won't subsist after minification)


/*
if (window.location.hash == "#MKMIN") {


  miniJS=function(report){
    document.filefox_form.filename.value="wait...";
    // collect all the files
//    var data=ConcatenatedJSFiles;
    var data="plop document.get.truc.bidule.machin";
    document.getElementById("sizespan").innerHTML=data.length+" bytes =>";
    data=JSminimize(data,report);
    document.getElementById("sizespan2").innerHTML=data.length+" bytes";

    document.filefox_form.filename.value="ygwm.prod.js";
//    document.filefox_form.filename.value="index.prod.js";
    // put the minified result (plus a header) in the form
    document.filefox_form.filecontents.value =
//      "/* index.prod.js : minified file generated from the YASEP source code tree,"
//     +" licensed under Affero GPL v3 by Yann Guidon, see http://yasep.org for all the details. \n"
//     +
       data;

//    FF.save_to_disk();
  }

  miniCSS=function(){
    document.filefox_form.filename.value="wait...";
    var data='';
    for (i in css_list)
      data+=LoadFile(css_list[i]+'.css')+"\n";

    document.filefox_form.filename.value="index.prod.css";
    document.filefox_form.filecontents.value =
//      "/* index.prod.css : minified file generated from the YASEP source code tree,"
//     +" licensed under Affero GPL v3 by Yann Guidon, see http://yasep.org for all the details. \n"
//     +
 JSminimize(data, "noSubst");
// JSminimize("rep /*plup lace (/plo p/g/ , \"pl ip\" + '/*' + /*  \"/\" ); /* ");
//    FF.save_to_disk();
  }

  // gather all the files, minimise them and write them
  body_start=function(){
    // replace the whole page contents
    document.body.innerHTML= '<p>Saving the minimised JavaScript file</p>'
       +FF.make_form('',100,30)
       +'<p> <input type="submit" onclick="miniCSS()" value="index.prod.css">'
       +'    <input type="submit" onclick="miniJS(\'noSubst\')"  value="index.prod.js">'
       +'    <input type="submit" onclick="miniJS()"  value="index.prod.js">'
       +'    <input type="submit" onclick="miniJS(\'report\')" value="index.prod.js.txt">'
       +' <span id="sizespan">...</span> &nbsp <span id="sizespan2">...</span></p>'
       +FF.make_ctl();
    FF.init();

    miniJS();
//    miniCSS();
  }
} else
*/
